/**
 * @function doSend
 */
"use strict";

const uuid = require('uuid');

/** @lends doSend */
function doSend(UserRecover, email, expireDuration) {
    let User = UserRecover.getRef('user').model;
    return User
        .findOne({
            where: {email: email}
        })
        .then(user => {
            if (!user) {
                return null;
            }
            return UserRecover
                .findOrCreate({
                    where: {
                        user_id: user.id
                    },
                    defaults: {
                        user_id: user.id
                    }
                })
                .then(recover => [].concat(recover || [])[0])
                .then(recover =>
                    recover.update({
                        expire_at: new Date(new Date() + expireDuration),
                        recover_token: uuid.v4().replace(/\-/g, ''),
                        recovered: false
                    })
                )
        })
}

module.exports = doSend;

